# gl_xyzdistort
# v 0.1 - use at your own risk
# (c) 12/2009 
# randomly distorts the position of each vertice in every selected face
# thanks to TIG

require 'sketchup.rb'

def gl_xyzdistort

model = Sketchup.active_model
entities = model.entities
selection = model.selection

prompts = ['Random Distortion Distance']
defaults = [0.to_l]
results = UI.inputbox prompts, defaults, 'max X distortion:'
xdistance = results [0]
results = UI.inputbox prompts, defaults, 'max Y distortion:'
ydistance = results [0]
results = UI.inputbox prompts, defaults, 'max Z distortion:'
zdistance = results [0]

model.start_operation "Distort"

selection.each do |e|
   if (e.is_a? Sketchup::Face)   
         for v in e.vertices
                 xrand=(-xdistance/2)+xdistance*rand
                 yrand=(-ydistance/2)+ydistance*rand
                 zrand=(-zdistance/2)+zdistance*rand
                 # puts(xrand, yrand, zrand)         
                 vector = Geom::Vector3d.new xrand,yrand,zrand
                 tr = Geom::Transformation.translation vector
                 Sketchup.active_model.entities.transform_entities(tr, v)
           end #for
   end #if
end #do

model.commit_operation

end #main



### Menu ###

if not file_loaded?(__FILE__)

  UI.menu("Plugins").add_item("~~~XYZDistort~~~"){gl_xyzdistort}

end #if


file_loaded(__FILE__)